/*
 *	maruji.c
 *
 *	܂؂ւvO
 *	Copyright (C) 2002 Naoyuki Sawa <nsawa@north.hokkai.net>
 *
 *	* Fri Jun 28 20:50:00 JST 2002 Naoyuki Sawa <nsawa@north.hokkai.net>
 *	- 쐬JnB
 */
#include <piece.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pcekn_sym.h"

char vbuff[DISP_X * DISP_Y];	/* z */

char font[/*0x1a000*/] = {	/* tHgf[^ */
#include "font.c"
};
#define FONTADDR ((unsigned char*)0xc0c000) /* ]AhX */

int phase;			/* ܂ȂɂĂ邩H */
#define PHASE_ERR	-1
#define PHASE_INIT	0
#define PHASE_WAIT	1

/****************************************************************************/

/* J[l֐ڌďo */
int
call(int addr)
{
	asm("call %r12");
}

/****************************************************************************/

/* bZ[W\ */
void
print(char* str)
{
	memset(vbuff, 0, sizeof vbuff);
	pceFontSetPos(0, 0);
	pceFontPutStr(str);
	pceLCDTrans();
}

/****************************************************************************/

void
pceAppInit()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();
}

/****************************************************************************/

void
pceAppProc(int count)
{
	int pad, ofs;
	const SYSTEMINFO* si;

	pad = pcePadGet();

	switch(phase) {
	case PHASE_ERR:
		if(pad & TRG_A) {
			pceAppReqExit(0);
		}
		return;

	case PHASE_INIT:
		/* o[W`FbN */
		si = pceSystemGetInfo();
		if(si->bios_ver != (1 << 8 | 18)) { /* 1.18`FbN */
			print("sł܂B\n"
			      "̃vO\n"
			      "BIOS1.18płB\n"
			      "\n"
			      "`{^ŏI܂B\n");
			phase = PHASE_ERR;
			return;
		}
		/* tbVAPI */
		call(pcekn_InitFlashAcc);
		print("`{^\n"
		      "܂ɐؑւ܂B\n"
		      "\n"
		      "a{^\n"
		      "fďI܂B\n");
		phase = PHASE_WAIT;
		return;

	case PHASE_WAIT:
		if(pad & TRG_B) {
			pceAppReqExit(0);
			return;
		}
		if(!(pad & TRG_A)) return; /* ҂p */
		/* sB */
		print("tbVłB\n"
		      "Tbقǂ҂B\n");
		for(ofs = 0; ofs < sizeof font; ofs += 0x1000) {
			pceFlashErase(FONTADDR + ofs);
			pceFlashWrite(FONTADDR + ofs, &font[ofs], 0x1000);
		}
		print("܂ɐؑւ܂B\n"
		      "̱ع݂͂sv\n"
		      "Ȃ̂ŏĂB\n"
		      "̃tHgɖ߂ɂ\n"
		      "VXeAbvf[g\n"
		      "sĂB\n"
		      "\n"
		      "`{^ŏI܂B\n");
		phase = PHASE_ERR; /* G[Ȃǂ`ŏÎ͓ */
		return;
	}

	/* ւ͗Ȃ͂B */
	print("G[łB\n"
	      "\n"
	      "`{^ŏI܂B\n");
	phase = PHASE_ERR;
}

/****************************************************************************/

void
pceAppExit()
{
}

